﻿using System;
using System.Collections.Generic;
using System.Net.Mail;
using System.Text;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Cms.Engine;
using Telerik.Cms.Web.UI;

using Telerik.Workflow;
using Telerik.Workflow.WebControls;
using Telerik;
using Telerik.Cms.Engine.Security;

namespace SelArom.Net.Sitefinity.Templates
{
	/// <summary>
	/// UserControl base for the ContentItemPreview external template to send notification emails for content status change
	/// </summary>
	public class GenericContentItemPreview : ContentItemPreviewBase
	{
		protected override void OnLoad(EventArgs e)
		{
			// initialize generic manager and local events manager
			mgr = new ContentManager(ContentManager.DefaultProviderName);

			// initialize everything else (including content item data)
			base.OnLoad(e);
		}

		protected override string ForApprovalMessage()
		{
			var sb = new StringBuilder();
			// create email body
			sb.AppendFormat("{0} has submitted an {2} item for approval!\n\nhttp://{1}/Sitefinity/Admin/Modules.aspx?module=News\n\n", usr.UserName, Request.Url.Host, mgr.DefaultProvider);
			sb.Append("\nPlease REVIEW the entry and correct any issues before approving for publication!");

			// add event details if found
			if (contentItem != null)
			{
				sb.Append("Item Details:\n\n");

				// ensure a title
				var title = contentItem.GetMetaData("Title");
				if (title == null) title = contentItem.GetMetaData("Name");
				if (title == null) title = "N/A";

				sb.AppendFormat("Title: {0}", title);
			}
			return sb.ToString();
		}

		protected override string ApprovedMessage()
		{
			var sb = new StringBuilder();
			// create email body
			sb.AppendFormat("{0} has approved an {2} item for publication!\n\nhttp://{1}/Sitefinity/Admin/Modules.aspx?module=News\n\n", usr.UserName, Request.Url.Host, mgr.DefaultProvider);

			// add event details if found
			if (contentItem != null)
			{
				sb.Append("Item Details:\n\n");

				// ensure a title
				var title = contentItem.GetMetaData("Title");
				if (title == null) title = contentItem.GetMetaData("Name");
				if (title == null) title = "N/A";

				sb.AppendFormat("Title: {0}", title);
			}
			return sb.ToString();
		}
	}
}